#ifndef HEADER_MySwisTrackClient
#define HEADER_MySwisTrackClient

#include "CommunicationNMEAInterface.h"

#define NUM_PIEXEL_DIST 5
#define MAX_NUM_PARTICLES 100

//! This is the main class of our sample program. It reads data from STDIN and passes them through the NMEA parser.
class MySwisTrackClient: public CommunicationNMEAInterface {
public:
	//! Constructor
	MySwisTrackClient();

	//! Main loop.
	void processData(char * buff, int len);

	// CommunicationNMEAInterface methods
	void OnNMEAProcessMessage(CommunicationMessage *m, bool withchecksum);
	void OnNMEAProcessMessageChecksumError(CommunicationMessage *m);
	void OnNMEAProcessUnrecognizedChar(char c);
	void OnNMEASend(const std::string &str);

    void setRadiusPixels(double p);
    void resetPixelDistances(int id);
    void sumPixelDistances(int id);
    void setNumParticles(int num);
    unsigned int getPacketCount(int id);
    void resetPacketCount(int id);

	//! Just as an example, we count the number of PARTICLE messages per frame
	int mParticleMessagesCount;
	//! Keeps track of the current frame number
	int mFrameNumber;

    unsigned int numOfParticles;
	double xPos[MAX_NUM_PARTICLES], yPos[MAX_NUM_PARTICLES];
	double xPosPrev[MAX_NUM_PARTICLES], yPosPrev[MAX_NUM_PARTICLES];
	//double xDiff, yDiff;
	double estOrient[MAX_NUM_PARTICLES];
	double estOrientPrev[MAX_NUM_PARTICLES];
	double xCenter[MAX_NUM_PARTICLES], yCenter[MAX_NUM_PARTICLES];
	double radiusPixels;
	double pixelDist[MAX_NUM_PARTICLES][NUM_PIEXEL_DIST];
	unsigned char pixelDistIndex[MAX_NUM_PARTICLES];
	double pixelDistSum[MAX_NUM_PARTICLES];
	double pixelDistTemp;
	unsigned int currentParticle;
	unsigned int packetCount[MAX_NUM_PARTICLES];

};

#endif
